## freeorion 0.5.1

=== CMakeLists.txt ===
if(WIN32)
    # file(GET_RUNTIME_DEPENDENCIES and install(... ALL_COMPONENTS)
    set(REQUIRED_CMAKE_VERSION 3.21)
else()
    # Python3_FIND_STRATEGY
    set(REQUIRED_CMAKE_VERSION 3.15)
endif()

cmake_minimum_required(VERSION ${REQUIRED_CMAKE_VERSION} FATAL_ERROR)

if(POLICY CMP0072)
  cmake_policy(SET CMP0072 NEW)
endif()

list(APPEND CMAKE_MODULE_PATH ${CMAKE_HOME_DIRECTORY}/cmake ${CMAKE_HOME_DIRECTORY}/GG/cmake)
set(CMAKE_OSX_DEPLOYMENT_TARGET 10.15 CACHE STRING "Set the minimum OSX deployment target version")
set(CMAKE_OSX_ARCHITECTURES x86_64 CACHE STRING "Set the architecture the universal binaries for OSX should be built for")

IF(CMAKE_GENERATOR STREQUAL "Xcode")
  set(CMAKE_CONFIGURATION_TYPES Release)
ELSE()
  set(CMAKE_CONFIGURATION_TYPES Debug RelWithDebInfo Release)
ENDIF()
IF(NOT CMAKE_BUILD_TYPE)
  MESSAGE(STATUS "Setting build type to 'Release' as none was specified.")
  SET(CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build." FORCE)
  # Set the possible values of build type for cmake-gui
  SET_PROPERTY(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug" "Release" "MinSizeRel" "RelWithDebInfo")
ENDIF(NOT CMAKE_BUILD_TYPE)

message(STATUS "Build type CMAKE_BUILD_TYPE set to ${CMAKE_BUILD_TYPE}")

include(UseCompilerCache)
find_compiler_cache(PROGRAM ccache)

list(APPEND GODOT_CPP_CMAKE_VARS "CMAKE_BUILD_TYPE;CMAKE_CONFIGURATION_TYPES;CMAKE_TOOLCHAIN_FILE;PYTHON_EXECUTABLE;Python3_EXECUTABLE")
get_cmake_property(vars CACHE_VARIABLES)
foreach(var ${vars})
  get_property(currentHelpString CACHE "${var}" PROPERTY HELPSTRING)
    if("${currentHelpString}" MATCHES "No help, variable specified on the command line." OR "${currentHelpString}" STREQUAL "")
      if(NOT "${var}" IN_LIST GODOT_CPP_CMAKE_VARS)
        list(APPEND CL_ARGS "-D${var}=${${var}}")
      endif()
    endif()
endforeach()


##
## Global project configuration
##

project(FreeOrion)

use_compiler_cache_with_xcode()

include(GNUInstallDirs)
include(UseCodeCoverage)
include(TargetDependencies)
include(CPackComponent)

set(CMAKE_CXX_STANDARD 20)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_VISIBILITY_PRESET hidden)

option(BUILD_SHARED_LIBS "Build project as shared libraries." ON)
option(BUILD_TESTING "Build the testing tree." OFF)
option(BUILD_CLIENT_GG "Build GiGi client" ON)
option(BUILD_CLIENT_GODOT "Build Godot client (experimental)" OFF)
option(BUILD_SERVER "Build server" ON)
option(BUILD_AI "Build AI" ON)
option(BUILD_PARSERS "Build parsers" ON)

set(GODOT_CPP_ROOT "" CACHE PATH "Path to Godot CPP libraries (empty to build internally)")

if(BUILD_TESTING)
    message( STATUS "Building Tests")
    enable_testing()
    enable_coverage()

    if(NOT TARGET unittest)
        add_custom_target(unittest
            COMMAND ${CMAKE_CTEST_COMMAND} --verbose --output-on-failure --build-config $<CONFIG>
            COMMENT "Run tests for ${CMAKE_PROJECT_NAME}"
        )
    endif()
endif()

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})

if(WIN32)
    # Location of the FreeOrionSDK root
    set(CMAKE_PREFIX_PATH "${CMAKE_SOURCE_DIR}/.." CACHE PATH "Location of the FreeOrionSDK root")
    # Search dependency DLLs inside FreeOrionSDK
    target_dependencies_add_search_path("${CMAKE_PREFIX_PATH}/bin")
    set(CMAKE_INSTALL_BINDIR ".")
    set(CMAKE_INSTALL_DATADIR ".")
    set(FreeOrion_INSTALL_LIBDIR ".")
else()
    set(CMAKE_INSTALL_DATADIR "${CMAKE_INSTALL_DATADIR}/freeorion")
endif()

if(APPLE)
    set(FreeOrionSDK_VERSION 14)
    set(FreeOrionSDK_FILE "FreeOrionSDK_${FreeOrionSDK_VERSION}_Clang-MacOSX-10.9-x86_64.tar.bz2")
    if(NOT EXISTS "${CMAKE_BINARY_DIR}/${FreeOrionSDK_FILE}")
    file(DOWNLOAD
            "https://github.com/freeorion/freeorion-sdk/releases/download/v${FreeOrionSDK_VERSION}/${FreeOrionSDK_FILE}"
            "${CMAKE_BINARY_DIR}/${FreeOrionSDK_FILE}"
            SHOW_PROGRESS
        )
    endif()
    set(FreeOrionSDK_INSTALL_VERSION 0)
    if(EXISTS "${CMAKE_BINARY_DIR}/dep/sdkversion")
        file(READ "${CMAKE_BINARY_DIR}/dep/sdkversion" FreeOrionSDK_INSTALL_VERSION)
    endif()
    if(NOT "${FreeOrionSDK_VERSION}" EQUAL "${FreeOrionSDK_INSTALL_VERSION}")
        file(REMOVE_RECURSE "${CMAKE_BINARY_DIR}/dep")
        file(MAKE_DIRECTORY "${CMAKE_BINARY_DIR}/dep")
        execute_process(COMMAND ${CMAKE_COMMAND} -E tar xfj "${CMAKE_BINARY_DIR}/${FreeOrionSDK_FILE}" WORKING_DIRECTORY "${CMAKE_BINARY_DIR}/dep")
        file(WRITE "${CMAKE_BINARY_DIR}/dep/sdkversion" "${FreeOrionSDK_VERSION}")
    endif()
    # Location of the FreeOrionSDK root
    set(CMAKE_PREFIX_PATH "${CMAKE_BINARY_DIR}/dep/")
    set(CMAKE_FRAMEWORK_PATH "${CMAKE_BINARY_DIR}/dep/Frameworks")
    set(CMAKE_PROGRAM_PATH "${CMAKE_BINARY_DIR}/dep/bin")
    set(Python3_FIND_FRAMEWORK "LAST")
    set(BOOST_ROOT "${CMAKE_BINARY_DIR}/dep/")
    set(Boost_NO_SYSTEM_PATHS ON)
    set(Python3_ROOT_DIR "${CMAKE_BINARY_DIR}/dep/")
    set(Python3_FIND_STRATEGY "LOCATION")
endif()

if(UNIX)
    set(FreeOrion_INSTALL_LIBDIR "${CMAKE_INSTALL_LIBDIR}/freeorion")
endif()

if(APPLE)
    set(CMAKE_INSTALL_RPATH
        "@loader_path/../SharedSupport"
        "@loader_path/../Frameworks"
    )
    set(CMAKE_BUILD_WITH_INSTALL_RPATH TRUE)
endif()

if(NOT APPLE)
    set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/${FreeOrion_INSTALL_LIBDIR}")
    set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
endif()

if(MSVC)
    # Remove default debug flags /Zi and /MDd to allow project-specific debug flag
    STRING(REGEX REPLACE " /Zi" "" CMAKE_CXX_FLAGS_DEBUG ${CMAKE_CXX_FLAGS_DEBUG})
    STRING(REGEX REPLACE " /Zi" "" CMAKE_CXX_FLAGS_RELWITHDEBINFO ${CMAKE_CXX_FLAGS_RELWITHDEBINFO})
    STRING(REGEX REPLACE " /MDd" "" CMAKE_CXX_FLAGS_DEBUG ${CMAKE_CXX_FLAGS_DEBUG})
endif()

add_compile_options(
    # Enable (almost) all warnings on compilers
    # https://gcc.gnu.org/onlinedocs/gcc/Warning-Options.html#index-Wall-316
    $<$<CXX_COMPILER_ID:GNU>:-Wall>
    # http://clang.llvm.org/docs/DiagnosticsReference.html#wall
    $<$<CXX_COMPILER_ID:Clang>:-Wall>
    # https://msdn.microsoft.com/en-us/library/thxezb7y.aspx#Anchor_1
    $<$<CXX_COMPILER_ID:MSVC>:/W4>

    # Disable "'<param>': unreferenced formal parameter" warning
    $<$<CXX_COMPILER_ID:MSVC>:/wd4100>
    # Disable "'<class>::<member>': class '<member-type>' needs to have dll-interface to be used by clients of class '<class>'" warning
    $<$<CXX_COMPILER_ID:MSVC>:/wd4251>
    # Disable "'<func>': unreferenced local function has been removed" warning
    $<$<CXX_COMPILER_ID:MSVC>:/wd4505>
    # Disable "declaration of '<type>' hides global declaration" warning
    $<$<CXX_COMPILER_ID:MSVC>:/wd4459>
    # Disable "function '<func>' marked as __forceinline not inlined" warning
    $<$<CXX_COMPILER_ID:MSVC>:/wd4714>

    # Enable C++ Exception unwind mechanics with DLL support
    $<$<CXX_COMPILER_ID:MSVC>:/EHsc>

    # Fix Fatal Error C1128: number of sections exceeded object file format limit : compile with /bigobj on SerializeEmpire.cpp
    $<$<CXX_COMPILER_ID:MSVC>:/bigobj>

    # Produce pdb files in Debug and RelWithDebInfo configuration
    $<$<AND:$<CXX_COMPILER_ID:MSVC>,$<OR:$<CONFIG:DEBUG>,$<CONFIG:RELWITHDEBINFO>>>:/Zi>
 
    # Use the multithread-specific and DLL-specific version of the run-time library in Debug Configuration
    $<$<AND:$<CXX_COMPILER_ID:MSVC>,$<CONFIG:DEBUG>>:/MD>
    
    # Set character set to UTF-8
    # https://docs.microsoft.com/en-us/cpp/build/reference/utf-8-set-source-and-executable-character-sets-to-utf-8?view=msvc-170
    $<$<CXX_COMPILER_ID:MSVC>:/utf-8>
)

# Determine minimum Windows target (see FreeOrion SDK)
if(WIN32)
    string(REGEX REPLACE "^v([1-9][0-9]*)(.*)$" "\\1;\\2" _VS_PLATFORM_TOOLSET "${CMAKE_VS_PLATFORM_TOOLSET}")
    message( STATUS "Toolset ${CMAKE_VS_PLATFORM_TOOLSET} regex ${_VS_PLATFORM_TOOLSET}")
    list(GET _VS_PLATFORM_TOOLSET 1 _VS_PLATFORM_TOOLSET_TARGET)
    message( STATUS "Target ${_VS_PLATFORM_TOOLSET_TARGET}")
endif()

set_property(DIRECTORY APPEND
    PROPERTY COMPILE_DEFINITIONS
        # Set minimum Windows target version to WindowsXP or Vista depending on toolset
        # https://msdn.microsoft.com/en-us/library/aa383745.aspx
        # Use numeric to correctly compare it in <boost\log\detail\config.hpp>
        $<$<PLATFORM_ID:Windows>:_WIN32_WINNT=$<IF:$<STREQUAL:${_VS_PLATFORM_TOOLSET_TARGET},_xp>,0x0501,0x0600>>
        # Default to unicode variants when using Win32 API
        # https://msdn.microsoft.com/en-us/library/dybsewaf.aspx
        $<$<PLATFORM_ID:Windows>:_UNICODE>
        # Disable "'<func>' was declared deprecated" warning
        # https://msdn.microsoft.com/en-us/library/ttcz0bys.aspx
        $<$<PLATFORM_ID:Windows>:_CRT_SECURE_NO_WARNINGS>
        # Disable '<func>': Function call with parameters that may be unsafe" warning
        # https://msdn.microsoft.com/en-us/library/ttcz0bys.aspx
        $<$<PLATFORM_ID:Windows>:_SCL_SECURE_NO_WARNINGS>
        # Disable '<func>': The POSIX name for this item is deprecated." warning
        # https://msdn.microsoft.com/en-us/library/ttcz0bys.aspx
        $<$<PLATFORM_ID:Windows>:_CRT_NONSTDC_NO_WARNINGS>

        # Suppress "Boost.Config is older than your compiler version" warning
        $<$<PLATFORM_ID:Windows>:BOOST_CONFIG_SUPPRESS_OUTDATED_MESSAGE>

        # Define platform specific macros
        $<$<PLATFORM_ID:Windows>:FREEORION_WIN32>
        $<$<PLATFORM_ID:Darwin>:FREEORION_MACOSX>
        $<$<PLATFORM_ID:Linux>:FREEORION_LINUX>
        $<$<PLATFORM_ID:FreeBSD>:FREEORION_FREEBSD>
        $<$<PLATFORM_ID:OpenBSD>:FREEORION_OPENBSD>
        $<$<PLATFORM_ID:NetBSD>:FREEORION_NETBSD>
        $<$<PLATFORM_ID:DragonFly>:FREEORION_DRAGONFLY>
        $<$<PLATFORM_ID:Haiku>:FREEORION_HAIKU>
        $<$<PLATFORM_ID:Android>:FREEORION_ANDROID>
)

if(WIN32 AND MSVC AND NOT (MSVC_VERSION LESS 1900)) # _MSC_VER >= 1900
    # fix https://bugs.python.org/issue36020
    # ToDo: remove after fix will be applied in python-cmake
    # ToDo: use GREATER_EQUAL after updating to cmake >= 3.7
    set_property(DIRECTORY APPEND
        PROPERTY COMPILE_DEFINITIONS
        HAVE_SNPRINTF
    )
endif()

if(WIN32 AND MSVC)
    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} /NODEFAULTLIB:LIBCMT")
    set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} /NODEFAULTLIB:LIBCMT")
endif()

if(UNIX AND NOT APPLE AND NOT ANDROID)
    add_definitions(-DENABLE_BINRELOC -DBINPATH=\"${CMAKE_INSTALL_FULL_BINDIR}\" -DSHAREPATH=\"${CMAKE_INSTALL_FULL_DATADIR}\")
endif()

include(TestForBug2795)


##
## Collect project dependencies.
##

set(MINIMUM_PYTHON_VERSION 3.9)
set(MINIMUM_BOOST_VERSION 1.73.0)

find_package(Threads)
if(ANDROID)
    find_package(Python3 ${MINIMUM_PYTHON_VERSION} COMPONENTS Interpreter REQUIRED)
    find_package(Python3 ${MINIMUM_PYTHON_VERSION} COMPONENTS Development REQUIRED)
else()
    find_package(Python3 ${MINIMUM_PYTHON_VERSION} COMPONENTS Interpreter Development REQUIRED)
endif()
message(STATUS "Python library version detected ${Python3_VERSION}")
set(Boost_PYTHON_SUFFIX "${Python3_VERSION_MAJOR}${Python3_VERSION_MINOR}")
message(STATUS "Boost python version ${Boost_PYTHON_SUFFIX}")
find_package(Boost ${MINIMUM_BOOST_VERSION}
    COMPONENTS
        filesystem
        iostreams
        locale
        log
        log_setup
        serialization
        system
        thread
    REQUIRED)

message(STATUS "Boost version detected ${Boost_MAJOR_VERSION}.${Boost_MINOR_VERSION}")

find_package(Boost OPTIONAL_COMPONENTS python${Boost_PYTHON_SUFFIX})
if(NOT Boost_PYTHON${Boost_PYTHON_SUFFIX}_FOUND)
    # try some strange boost installations
    string(SUBSTRING "${Boost_PYTHON_SUFFIX}" 0 1 Boost_PYTHON_SUFFIX)
    find_package(Boost COMPONENTS python${Boost_PYTHON_SUFFIX} REQUIRED)
endif()

if(BUILD_TESTING)
    find_package(Boost ${MINIMUM_BOOST_VERSION} COMPONENTS unit_test_framework REQUIRED)
endif()

=== check/CMakeLists.txt ===
find_package(CPPCheck)

if(TARGET Cppcheck::cppcheck)
    add_custom_target(check-cpp
        COMMAND
            "$<TARGET_FILE:Cppcheck::cppcheck>"
            --quiet
            --template=gcc
            --std=c++14
            ${PROJECT_SOURCE_DIR}
        COMMENT "Check C++ for problematic code"
    )
endif()


if(NOT TARGET check)
    add_custom_target(check
        COMMENT "Run code quality checks"
    )
endif()

if(TARGET check-cpp)
    add_dependencies(check check-cpp)
endif()

if(TARGET check-pep8)
    add_dependencies(check check-pep8)
endif()

if(TARGET check-pep8-focs)
    add_dependencies(check check-pep8-focs)
endif()

if(TARGET check-pep8-focs-test)
    add_dependencies(check check-pep8-focs-test)
endif()

=== client/CMakeLists.txt ===
if(BUILD_AI)
    add_subdirectory(AI)
endif()
if(BUILD_CLIENT_GG)
    add_subdirectory(human)
endif()
if(BUILD_CLIENT_GODOT)
    add_subdirectory(godot)
endif()

if(BUILD_AI)
    target_sources(freeorionca
        PUBLIC
            ${CMAKE_CURRENT_LIST_DIR}/ClientApp.h
            ${CMAKE_CURRENT_LIST_DIR}/ClientFSMEvents.h
            ${CMAKE_CURRENT_LIST_DIR}/ClientNetworking.h
        PRIVATE
            ${CMAKE_CURRENT_LIST_DIR}/ClientApp.cpp
            ${CMAKE_CURRENT_LIST_DIR}/ClientFSMEvents.cpp
            ${CMAKE_CURRENT_LIST_DIR}/ClientNetworking.cpp
    )
endif()

if(BUILD_CLIENT_GG)
    target_sources(freeorion
        PUBLIC
            ${CMAKE_CURRENT_LIST_DIR}/ClientApp.h
            ${CMAKE_CURRENT_LIST_DIR}/ClientFSMEvents.h
            ${CMAKE_CURRENT_LIST_DIR}/ClientNetworking.h
        PRIVATE
            ${CMAKE_CURRENT_LIST_DIR}/ClientApp.cpp
            ${CMAKE_CURRENT_LIST_DIR}/ClientFSMEvents.cpp
            ${CMAKE_CURRENT_LIST_DIR}/ClientNetworking.cpp
    )
endif()

if(BUILD_CLIENT_GODOT)
    target_sources(freeoriongodot
        PUBLIC
            ${CMAKE_CURRENT_LIST_DIR}/ClientApp.h
            ${CMAKE_CURRENT_LIST_DIR}/ClientFSMEvents.h
            ${CMAKE_CURRENT_LIST_DIR}/ClientNetworking.h
        PRIVATE
            ${CMAKE_CURRENT_LIST_DIR}/ClientApp.cpp
            ${CMAKE_CURRENT_LIST_DIR}/ClientFSMEvents.cpp
            ${CMAKE_CURRENT_LIST_DIR}/ClientNetworking.cpp
    )
endif()

=== doc/CMakeLists.txt ===
find_package(Doxygen)

if(DOXYGEN_FOUND)
    set(FreeOrion_CPP_APIDOC_OUTDIR ${CMAKE_CURRENT_BINARY_DIR}/cpp-apidoc)

    configure_file(
        ${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in
        ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
        @ONLY
    )

    if(NOT TARGET doc)
        add_custom_target(doc)
    endif()

    add_custom_target(cpp-apidoc
        ${PYTHON_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/tag_parser.py --match ${FreeOrion_SOURCE_DIR}/default -f "*.py" "*.focs.txt" "*.macros" -o ${FreeOrion_CPP_APIDOC_OUTDIR}/all_tags.dox --link_source ${FreeOrion_SOURCE_DIR} "https://github.com/freeorion/freeorion/blob/master/" "#L" &&
        ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
        WORKING_DIRECTORY ${FreeOrion_SOURCE_DIR}
        COMMENT "Generating FreeOrion API documentation with Doxygen" VERBATIM
    )

    add_dependencies(doc cpp-apidoc)
endif()

=== parse/CMakeLists.txt ===

if(BUILD_PARSERS)
    target_sources(freeorionparseobj
        PUBLIC
            ${CMAKE_CURRENT_LIST_DIR}/MovableEnvelope.h
            ${CMAKE_CURRENT_LIST_DIR}/Parse.h
            ${CMAKE_CURRENT_LIST_DIR}/PythonParser.h
        PRIVATE
            ${CMAKE_CURRENT_LIST_DIR}/CommonParamsParser.h
            ${CMAKE_CURRENT_LIST_DIR}/ConditionParser.h
            ${CMAKE_CURRENT_LIST_DIR}/ConditionParser1.h
            ${CMAKE_CURRENT_LIST_DIR}/ConditionParser2.h
            ${CMAKE_CURRENT_LIST_DIR}/ConditionParser3.h
            ${CMAKE_CURRENT_LIST_DIR}/ConditionParser4.h
            ${CMAKE_CURRENT_LIST_DIR}/ConditionParser5.h
            ${CMAKE_CURRENT_LIST_DIR}/ConditionParser6.h
            ${CMAKE_CURRENT_LIST_DIR}/ConditionParser7.h
            ${CMAKE_CURRENT_LIST_DIR}/ConditionParserImpl.h
            ${CMAKE_CURRENT_LIST_DIR}/EffectParser.h
            ${CMAKE_CURRENT_LIST_DIR}/EffectParser1.h
            ${CMAKE_CURRENT_LIST_DIR}/EffectParser2.h
            ${CMAKE_CURRENT_LIST_DIR}/EffectParser3.h
            ${CMAKE_CURRENT_LIST_DIR}/EffectParser4.h
            ${CMAKE_CURRENT_LIST_DIR}/EffectParser5.h
            ${CMAKE_CURRENT_LIST_DIR}/EffectParserImpl.h
            ${CMAKE_CURRENT_LIST_DIR}/EffectPythonParser.h
            ${CMAKE_CURRENT_LIST_DIR}/EnumParser.h
            ${CMAKE_CURRENT_LIST_DIR}/EnumPythonParser.h
            ${CMAKE_CURRENT_LIST_DIR}/EnumValueRefRules.h
            ${CMAKE_CURRENT_LIST_DIR}/Lexer.h
            ${CMAKE_CURRENT_LIST_DIR}/ParseImpl.h
            ${CMAKE_CURRENT_LIST_DIR}/ReportParseError.h
            ${CMAKE_CURRENT_LIST_DIR}/Tokens.h
            ${CMAKE_CURRENT_LIST_DIR}/ValueRefParser.h
            ${CMAKE_CURRENT_LIST_DIR}/ArithmeticRules.cpp
            ${CMAKE_CURRENT_LIST_DIR}/BuildingsParser.cpp
            ${CMAKE_CURRENT_LIST_DIR}/CommonParamsParser.cpp
            ${CMAKE_CURRENT_LIST_DIR}/ConditionParser1.cpp
            ${CMAKE_CURRENT_LIST_DIR}/ConditionParser2.cpp
            ${CMAKE_CURRENT_LIST_DIR}/ConditionParser3.cpp
            ${CMAKE_CURRENT_LIST_DIR}/ConditionParser4.cpp
            ${CMAKE_CURRENT_LIST_DIR}/ConditionParser5.cpp
            ${CMAKE_CURRENT_LIST_DIR}/ConditionParser6.cpp
            ${CMAKE_CURRENT_LIST_DIR}/ConditionParser7.cpp
            ${CMAKE_CURRENT_LIST_DIR}/ConditionParser.cpp
            ${CMAKE_CURRENT_LIST_DIR}/DoubleComplexValueRefParser.cpp
            ${CMAKE_CURRENT_LIST_DIR}/DoubleValueRefParser.cpp
            ${CMAKE_CURRENT_LIST_DIR}/EffectParser1.cpp
            ${CMAKE_CURRENT_LIST_DIR}/EffectParser2.cpp
            ${CMAKE_CURRENT_LIST_DIR}/EffectParser3.cpp
            ${CMAKE_CURRENT_LIST_DIR}/EffectParser4.cpp
            ${CMAKE_CURRENT_LIST_DIR}/EffectParser5.cpp
            ${CMAKE_CURRENT_LIST_DIR}/EffectParser.cpp
            ${CMAKE_CURRENT_LIST_DIR}/EffectPythonParser.cpp
            ${CMAKE_CURRENT_LIST_DIR}/EmpireStatsParser.cpp
            ${CMAKE_CURRENT_LIST_DIR}/EncyclopediaParser.cpp
            ${CMAKE_CURRENT_LIST_DIR}/EnumParser.cpp
            ${CMAKE_CURRENT_LIST_DIR}/EnumPythonParser.cpp
            ${CMAKE_CURRENT_LIST_DIR}/FieldsParser.cpp
            ${CMAKE_CURRENT_LIST_DIR}/FleetPlansParser.cpp
            ${CMAKE_CURRENT_LIST_DIR}/GameRulesParser.cpp
            ${CMAKE_CURRENT_LIST_DIR}/IntComplexValueRefParser.cpp
            ${CMAKE_CURRENT_LIST_DIR}/IntValueRefParser.cpp
            ${CMAKE_CURRENT_LIST_DIR}/ItemsParser.cpp
            ${CMAKE_CURRENT_LIST_DIR}/Lexer.cpp
            ${CMAKE_CURRENT_LIST_DIR}/MonsterFleetPlansParser.cpp
            ${CMAKE_CURRENT_LIST_DIR}/NamedValueRefParser.cpp
            ${CMAKE_CURRENT_LIST_DIR}/Parse.cpp
            ${CMAKE_CURRENT_LIST_DIR}/PlanetEnvironmentValueRefParser.cpp
            ${CMAKE_CURRENT_LIST_DIR}/PlanetSizeValueRefParser.cpp
            ${CMAKE_CURRENT_LIST_DIR}/PlanetTypeValueRefParser.cpp
            ${CMAKE_CURRENT_LIST_DIR}/PoliciesParser.cpp
            ${CMAKE_CURRENT_LIST_DIR}/ReportParseError.cpp
            ${CMAKE_CURRENT_LIST_DIR}/ShipDesignsParser.cpp
            ${CMAKE_CURRENT_LIST_DIR}/ShipHullsParser.cpp
            ${CMAKE_CURRENT_LIST_DIR}/ShipPartsParser.cpp
            ${CMAKE_CURRENT_LIST_DIR}/SpecialsParser.cpp
            ${CMAKE_CURRENT_LIST_DIR}/SpeciesParser.cpp
            ${CMAKE_CURRENT_LIST_DIR}/StarTypeValueRefParser.cpp
            ${CMAKE_CURRENT_LIST_DIR}/StringComplexValueRefParser.cpp
            ${CMAKE_CURRENT_LIST_DIR}/StringValueRefParser.cpp
            ${CMAKE_CURRENT_LIST_DIR}/TechsParser.cpp
            ${CMAKE_CURRENT_LIST_DIR}/UniverseObjectTypeValueRefParser.cpp
            ${CMAKE_CURRENT_LIST_DIR}/ValueRefParser.cpp
            ${CMAKE_CURRENT_LIST_DIR}/ValueRefPythonParser.cpp
            ${CMAKE_CURRENT_LIST_DIR}/VisibilityValueRefParser.cpp
            ${CMAKE_CURRENT_LIST_DIR}/PythonParser.cpp
            ${CMAKE_CURRENT_LIST_DIR}/SourcePythonParser.cpp
            ${CMAKE_CURRENT_LIST_DIR}/ConditionPythonParser.cpp
            ${CMAKE_CURRENT_LIST_DIR}/ConditionPythonParser.h
            ${CMAKE_CURRENT_LIST_DIR}/EffectPythonParser.h
            ${CMAKE_CURRENT_LIST_DIR}/EnumPythonParser.h
            ${CMAKE_CURRENT_LIST_DIR}/SourcePythonParser.h
            ${CMAKE_CURRENT_LIST_DIR}/ValueRefPythonParser.h
    )
else()
    target_sources(freeorionparseobj
        PUBLIC
            ${CMAKE_CURRENT_LIST_DIR}/Parse.h
            ${CMAKE_CURRENT_LIST_DIR}/PythonParser.h
        PRIVATE
            ${CMAKE_CURRENT_LIST_DIR}/DummyParsers.cpp
    )
endif()

=== server/CMakeLists.txt ===
target_sources(freeoriond
    PUBLIC
        ${CMAKE_CURRENT_LIST_DIR}/SaveLoad.h
        ${CMAKE_CURRENT_LIST_DIR}/ServerApp.h
        ${CMAKE_CURRENT_LIST_DIR}/ServerFramework.h
        ${CMAKE_CURRENT_LIST_DIR}/ServerFSM.h
        ${CMAKE_CURRENT_LIST_DIR}/ServerNetworking.h
        ${CMAKE_CURRENT_LIST_DIR}/ServerWrapper.h
        ${CMAKE_CURRENT_LIST_DIR}/UniverseGenerator.h
    PRIVATE
        ${CMAKE_CURRENT_LIST_DIR}/dmain.cpp
        ${CMAKE_CURRENT_LIST_DIR}/SaveLoad.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ServerApp.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ServerFramework.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ServerFSM.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ServerNetworking.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ServerWrapper.cpp
        ${CMAKE_CURRENT_LIST_DIR}/UniverseGenerator.cpp
)

=== util/CMakeLists.txt ===
target_sources(freeorioncommon
    PUBLIC
        ${CMAKE_CURRENT_LIST_DIR}/AppInterface.h
        ${CMAKE_CURRENT_LIST_DIR}/base64_filter.h
        ${CMAKE_CURRENT_LIST_DIR}/blocking_combiner.h
        ${CMAKE_CURRENT_LIST_DIR}/CheckSums.h
        ${CMAKE_CURRENT_LIST_DIR}/Directories.h
        ${CMAKE_CURRENT_LIST_DIR}/Enum.h
        ${CMAKE_CURRENT_LIST_DIR}/i18n.h
        ${CMAKE_CURRENT_LIST_DIR}/Logger.h
        ${CMAKE_CURRENT_LIST_DIR}/LoggerWithOptionsDB.h
        ${CMAKE_CURRENT_LIST_DIR}/ModeratorAction.h
        ${CMAKE_CURRENT_LIST_DIR}/MultiplayerCommon.h
        ${CMAKE_CURRENT_LIST_DIR}/OptionsDB.h
        ${CMAKE_CURRENT_LIST_DIR}/OptionValidators.h
        ${CMAKE_CURRENT_LIST_DIR}/Order.h
        ${CMAKE_CURRENT_LIST_DIR}/OrderSet.h
        ${CMAKE_CURRENT_LIST_DIR}/Pending.h
        ${CMAKE_CURRENT_LIST_DIR}/Process.h
        ${CMAKE_CURRENT_LIST_DIR}/PythonCommon.h
        ${CMAKE_CURRENT_LIST_DIR}/Random.h
        ${CMAKE_CURRENT_LIST_DIR}/SaveGamePreviewUtils.h
        ${CMAKE_CURRENT_LIST_DIR}/ScopedTimer.h
        ${CMAKE_CURRENT_LIST_DIR}/Serialize.h
        ${CMAKE_CURRENT_LIST_DIR}/Serialize.ipp
        ${CMAKE_CURRENT_LIST_DIR}/SitRepEntry.h
        ${CMAKE_CURRENT_LIST_DIR}/StringTable.h
        ${CMAKE_CURRENT_LIST_DIR}/VarText.h
        ${CMAKE_CURRENT_LIST_DIR}/Version.h
        ${CMAKE_CURRENT_LIST_DIR}/XMLDoc.h
    PRIVATE
        ${CMAKE_CURRENT_LIST_DIR}/AppInterface.cpp
        ${CMAKE_CURRENT_LIST_DIR}/CheckSums.cpp
        ${CMAKE_CURRENT_LIST_DIR}/Directories.cpp
        ${CMAKE_CURRENT_LIST_DIR}/GameRules.cpp
        ${CMAKE_CURRENT_LIST_DIR}/i18n.cpp
        ${CMAKE_CURRENT_LIST_DIR}/Logger.cpp
        ${CMAKE_CURRENT_LIST_DIR}/LoggerWithOptionsDB.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ModeratorAction.cpp
        ${CMAKE_CURRENT_LIST_DIR}/MultiplayerCommon.cpp
        ${CMAKE_CURRENT_LIST_DIR}/OptionsDB.cpp
        ${CMAKE_CURRENT_LIST_DIR}/Order.cpp
        ${CMAKE_CURRENT_LIST_DIR}/OrderSet.cpp
        ${CMAKE_CURRENT_LIST_DIR}/Process.cpp
        ${CMAKE_CURRENT_LIST_DIR}/PythonCommon.cpp
        ${CMAKE_CURRENT_LIST_DIR}/Random.cpp
        ${CMAKE_CURRENT_LIST_DIR}/SaveGamePreviewUtils.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ScopedTimer.cpp
        ${CMAKE_CURRENT_LIST_DIR}/SerializeCombat.cpp
        ${CMAKE_CURRENT_LIST_DIR}/SerializeEmpire.cpp
        ${CMAKE_CURRENT_LIST_DIR}/SerializeModeratorAction.cpp
        ${CMAKE_CURRENT_LIST_DIR}/SerializeMultiplayerCommon.cpp
        ${CMAKE_CURRENT_LIST_DIR}/SerializeOrderSet.cpp
        ${CMAKE_CURRENT_LIST_DIR}/SerializeQueues.cpp
        ${CMAKE_CURRENT_LIST_DIR}/SerializeSpecies.cpp
        ${CMAKE_CURRENT_LIST_DIR}/SerializeUniverse.cpp
        ${CMAKE_CURRENT_LIST_DIR}/SitRepEntry.cpp
        ${CMAKE_CURRENT_LIST_DIR}/StringTable.cpp
        ${CMAKE_CURRENT_LIST_DIR}/VarText.cpp
        ${CMAKE_CURRENT_LIST_DIR}/Version.cpp
        ${CMAKE_CURRENT_LIST_DIR}/XMLDoc.cpp
        $<$<NOT:$<PLATFORM_ID:Windows>>:${CMAKE_CURRENT_LIST_DIR}/binreloc.c>
)

if(BUILD_SERVER)
    target_sources(freeoriond
        PRIVATE
            ${CMAKE_CURRENT_LIST_DIR}/DependencyVersions.cpp
    )
endif()

if(BUILD_AI)
    target_sources(freeorionca
        PRIVATE
            ${CMAKE_CURRENT_LIST_DIR}/DependencyVersions.cpp
    )
endif()

if(BUILD_CLIENT_GG)
    target_sources(freeorion
        PRIVATE
            ${CMAKE_CURRENT_LIST_DIR}/DependencyVersions.cpp
    )
endif()

if(BUILD_CLIENT_GODOT)
    target_sources(freeoriongodot
        PRIVATE
            ${CMAKE_CURRENT_LIST_DIR}/DependencyVersions.cpp
    )
endif()

=== GG/test/CMakeLists.txt ===
# GiGi - A GUI for OpenGL
#
#  Copyright (C) 2017 Marcel Metz
#  Copyright (C) 2013-2020 The FreeOrion Project
#
# Released under the GNU Lesser General Public License 2.1 or later.
# Some Rights Reserved.  See COPYING file or https://www.gnu.org/licenses/lgpl-2.1.txt
# SPDX-License-Identifier: LGPL-2.1-or-later

add_subdirectory(unit)

=== UI/CombatReport/CMakeLists.txt ===
target_sources(freeorion
    PUBLIC
        ${CMAKE_CURRENT_LIST_DIR}/CombatLogWnd.h
        ${CMAKE_CURRENT_LIST_DIR}/CombatReportData.h
        ${CMAKE_CURRENT_LIST_DIR}/CombatReportWnd.h
        ${CMAKE_CURRENT_LIST_DIR}/GraphicalSummary.h
    PRIVATE
        ${CMAKE_CURRENT_LIST_DIR}/GraphicalSummary.cpp
        ${CMAKE_CURRENT_LIST_DIR}/CombatLogWnd.cpp
        ${CMAKE_CURRENT_LIST_DIR}/CombatReportData.cpp
        ${CMAKE_CURRENT_LIST_DIR}/CombatReportWnd.cpp
)

=== client/godot/CMakeLists.txt ===
target_sources(freeoriongodot
    PRIVATE
        ${CMAKE_CURRENT_LIST_DIR}/FreeOrionNode.h
        ${CMAKE_CURRENT_LIST_DIR}/GodotClientApp.h
        ${CMAKE_CURRENT_LIST_DIR}/GodotFleet.h
        ${CMAKE_CURRENT_LIST_DIR}/GodotSystem.h

        ${CMAKE_CURRENT_LIST_DIR}/cgmain.cpp
        ${CMAKE_CURRENT_LIST_DIR}/FreeOrionNode.cpp
        ${CMAKE_CURRENT_LIST_DIR}/GodotClientApp.cpp
        ${CMAKE_CURRENT_LIST_DIR}/GodotFleet.cpp
        ${CMAKE_CURRENT_LIST_DIR}/GodotSystem.cpp
)

=== test/UI/CMakeLists.txt ===
macro(ADD_FO_ACCEPTANCE_TEST name)
    add_executable(fo_acceptance_${name}
        ${ARGN}
    )
    target_link_libraries(fo_acceptance_${name}
        fo_acceptance_runner
    )
endmacro()

find_package(GLEW REQUIRED)

include_directories(
    SYSTEM
    ${OPENGL_INCLUDE_DIR}
)

add_library(fo_acceptance_runner STATIC
    runner/Application.cpp
    runner/Dialog.cpp
    runner/ResourceCursor.cpp
    ../../UI/SDLGUI.cpp
)

target_link_libraries(fo_acceptance_runner
    PUBLIC
        Boost::system
        GiGi::GiGi
        GLEW::GLEW
        ${SDL_LIBRARIES}
)

target_include_directories(fo_acceptance_runner
    PUBLIC
        ${SDL_INCLUDE_DIR}
)

add_fo_acceptance_test(text_control TestTextControl.cpp)

=== test/parse/CMakeLists.txt ===
find_package(Boost ${MINIMUM_BOOST_VERSION} COMPONENTS unit_test_framework REQUIRED)

add_executable(fo_unittest_parse
    main.cpp
    CommonTest.cpp
    ParserAppFixture.cpp
    $<TARGET_OBJECTS:freeorionparseobj>
)

target_compile_definitions(fo_unittest_parse
    PRIVATE
        -DFREEORION_BUILD_SERVER
)

target_include_directories(fo_unittest_parse
    PRIVATE
        ${PROJECT_SOURCE_DIR}
)

target_link_libraries(fo_unittest_parse
    freeorioncommon
    freeorionparse
    Threads::Threads
    Boost::boost
    Boost::disable_autolinking
    Boost::dynamic_linking
    Boost::unit_test_framework
)

target_dependencies_copy_to_build(fo_unittest_parse)
target_dependent_data_symlink_to_build(fo_unittest_parse ${PROJECT_SOURCE_DIR}/test-scripting)
target_dependent_data_symlink_to_build(fo_unittest_parse ${PROJECT_SOURCE_DIR}/default)

add_coverage(fo_unittest_parse
    unittest
)

add_dependencies(unittest
    fo_unittest_parse
)

set(FO_TEST_PARSE
    TestEnumParser
    #TestValueRefDoubleParser
    #TestValueRefIntParser
    #TestValueRefStringParser
    #TestValueRefUniverseObjectTypeParser
    #TestScriptParser
    TestPythonParser
    TestDefaultPythonParser
)

foreach(_TEST ${FO_TEST_PARSE})
    target_sources(fo_unittest_parse
        PRIVATE
        ${_TEST}.cpp
    )
    add_test(
        NAME ${_TEST}
        COMMAND fo_unittest_parse --log_level=all "--run_test=${_TEST}" --catch_system_error=yes
        WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
    )
endforeach()

=== debian/changelog ===
freeorion (0.5.1-2build4) questing; urgency=medium

  * No-change rebuild for boost 1.88.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 12 Aug 2025 10:24:46 +0200

freeorion (0.5.1-2build3) questing; urgency=medium

  * No-change rebuild for boost 1.88.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 06 Aug 2025 17:04:49 +0200

freeorion (0.5.1-2build2) questing; urgency=medium

  * No-change rebuild for boost 1.88.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 06 Aug 2025 17:04:08 +0200

freeorion (0.5.1-2build1) questing; urgency=medium

  * No-change rebuild for boost 1.88.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 06 Aug 2025 16:54:24 +0200

freeorion (0.5.1-2) unstable; urgency=medium

  * Team upload.

  [ O01eg ]
  * Remove optional dependency on RC-buggy cppcheck (Closes: #1101098)

 -- Alexandre Detiste <tchet@debian.org>  Sun, 23 Mar 2025 11:48:37 +0100

freeorion (0.5.1-1) unstable; urgency=medium

  * Team upload.
  * New upstream release compatible with GCC-15 (Closes: #1096657)

 -- Alexandre Detiste <tchet@debian.org>  Sat, 22 Mar 2025 18:49:28 +0100

freeorion (0.5.0.1-1) unstable; urgency=medium

  * Team Upload
  * New upstream version 0.5.0.1 (Closes: #1074967)
  * Update Build-Depends: replace pkg-config with pkgconf

 -- Alexandre Detiste <tchet@debian.org>  Wed, 21 Aug 2024 13:29:04 +0200

=== debian/control ===
Source: freeorion
Section: games
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders:
 Markus Koschany <apo@debian.org>,
Build-Depends:
 debhelper-compat (= 13),
 dh-python,
 cmake,
 libalut-dev,
 libboost-all-dev,
 libfreetype-dev,
 libgl-dev,
 libglew-dev,
 libglu1-mesa-dev,
 libjpeg-dev,
 libogg-dev,
 libopenal-dev,
 libpng-dev,
 libsdl2-dev,
 libtiff-dev,
 libvorbis-dev,
 pkgconf,
 python3,
Rules-Requires-Root: no
Standards-Version: 4.6.2
Homepage: https://www.freeorion.org/index.php/Main_Page
Vcs-Git: https://salsa.debian.org/games-team/freeorion.git
Vcs-Browser: https://salsa.debian.org/games-team/freeorion
X-Style: black

Package: freeorion
Architecture: linux-any
Depends:
 freeorion-data (= ${source:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: turn-based space empire and galactic conquest game
 FreeOrion is a turn-based space empire and galactic conquest (4X) game being
 designed and built by the FreeOrion project. FreeOrion is inspired by the
 tradition of the Master of Orion games, but is not a clone or remake of that
 series or any other game.
 .
 The game is about the construction of a living, breathing universe in a grand
 campaign model. You can develop your own galactic empire and explore new star
 systems with your fleets as one of several unique human or alien species.
 Colonization of new worlds, researching new technology, managing your
 resources and defending your planets against the AI or other human players on
 a galactic scale are your main objectives.

Package: freeorion-data
Architecture: all
Depends:
 fonts-dejavu,
 fonts-roboto-unhinted,
 ${misc:Depends},
 ${python3:Depends},
Suggests:
 freeorion,
Description: turn-based space empire and galactic conquest game -- data
 FreeOrion is a turn-based space empire and galactic conquest (4X) game being
 designed and built by the FreeOrion project.
 .
 This package provides architecture-independent data files for FreeOrion,
 hundreds of unique designs for in-game icons, ships and planets, many
 different sounds and an immersive music score.
 .
 Also included are in-game descriptions, translations and game scripts.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1
export CCACHE_DIR=$(CURDIR)/ccache
DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

MAX  := 2
TYPE := RelWithDebInfo

ifeq (32,$(DEB_HOST_ARCH_BITS))
	MAX  := 1
	TYPE := Release
	export DEB_CFLAGS_MAINT_APPEND = -g1 -O2
	export DEB_CXXFLAGS_MAINT_APPEND = -g1 -O2
endif

%:
	dh $@ --max-parallel=$(MAX) --with python3

override_dh_auto_configure:
	dh_auto_configure -- \
		-DBUILD_DOCUMENTATION=off \
		-DBUILD_TUTORIALS=off \
		-DLIB_SUFFIX=/freeorion \
		-DCMAKE_VERBOSE_MAKEFILE=ON \
		-DCMAKE_BUILD_TYPE=$(TYPE)

#workaround for 'dpkg-shlibdeps: error: couldn't find library libGiGi*.so'
override_dh_shlibdeps:
	LD_LIBRARY_PATH="$(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/freeorion:$(LD_LIBRARY_PATH)" dh_shlibdeps

override_dh_installchangelogs:
	dh_installchangelogs ChangeLog.md

override_dh_install:
	dh_install
	find debian -type d -empty -delete -printf 'removed %p\n'
	$(RM) -v debian/freeorion-data/usr/share/games/freeorion/default/LICENSE* \
		debian/freeorion-data/usr/share/games/freeorion/default/COPYING \
		debian/freeorion-data/usr/share/games/freeorion/default/data/fonts/LICENSE.*

override_dh_python3:
	dh_python3 -pfreeorion-data /usr/share/games
